//+------------------------------------------------------------------+
//|                                                    _Benjamin.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include <Trade\Trade.mqh>


input string           inp_str0 =                       "__________________________________";
input double           inp_ord_Lot =      0.01;         //Lot
input ulong            inp_magic=         123;          //Magic
input string           inp_str1 =                       "__________________________________";
input int              inp_profit_pls  =                100; //ProfitAll pls close (0 - off)
input int              inp_profit_mns  =               -100; //ProfitAll mns close (0 - off)
input int              inp_profitB_pls  =                100; //ProfitBuy pls close (0 - off)
input int              inp_profitB_mns  =               -100; //ProfitBuy mns close (0 - off)
input int              inp_profitS_pls  =                5; //ProfitSell pls close (0 - off)
input int              inp_profitS_mns  =               -5; //ProfitSell mns close (0 - off)

CTrade  gl_trade;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit(){
   MathSrand(GetTickCount());
  
   gl_trade.SetExpertMagicNumber(inp_magic);
   //---Filing mode
   int filling_mode = int(SymbolInfoInteger(_Symbol, SYMBOL_FILLING_MODE));
   if ((SYMBOL_FILLING_IOC & filling_mode)== SYMBOL_FILLING_IOC ){ gl_trade.SetTypeFilling(ORDER_FILLING_IOC);} else{  
   if ((SYMBOL_FILLING_FOK & filling_mode)== SYMBOL_FILLING_FOK ){ gl_trade.SetTypeFilling(ORDER_FILLING_FOK);} else{
                                                                   gl_trade.SetTypeFilling(ORDER_FILLING_RETURN);}}     
   //---
   return(INIT_SUCCEEDED);}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){

   string strB, strS; 
   double profit_buy  = 0 ; bool b_profit_buy  = Fn_profit_summ(strB, profit_buy , true , inp_magic);  
   double profit_sell = 0 ; bool b_profit_sell = Fn_profit_summ(strS, profit_sell, false, inp_magic); 
   double profit_all  = profit_buy+profit_sell ; 
   
   Comment("profit buy : "+DoubleToString(profit_buy ,2)+"$"+strB+"\n"+
           "profit sell: "+DoubleToString(profit_sell,2)+"$"+strS+"\n");
   
   if(b_profit_buy && b_profit_sell){
      if( Fn_is_close (inp_profit_pls , profit_all , inp_profit_mns ) ) Fn_ord_cls_all(-1   , inp_magic); else { 
      if( Fn_is_close (inp_profitB_pls, profit_buy , inp_profitB_mns) ) Fn_ord_cls_all(true , inp_magic); else {
      if( Fn_is_close (inp_profitS_pls, profit_sell, inp_profitS_mns) ){ Fn_ord_cls_all(false, inp_magic); Print(DoubleToString(profit_sell, 2)+"$");}}}
      
      }
   //--------------- set orders every bar
   static datetime time_old=0;
          datetime time_new=iTime(_Symbol, PERIOD_CURRENT, 0); 
   
   if(time_new>0 && time_new!=time_old){
      bool is_buy=Signal(); 
      if(is_buy) gl_trade.Buy (NormalizeLot(_Symbol, inp_ord_Lot), _Symbol);
      else       gl_trade.Sell(NormalizeLot(_Symbol, inp_ord_Lot), _Symbol); 
      time_old=time_new;}
  //--------------- 
}      
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){ }
//+------------------------------------------------------------------+
bool Fn_is_close(double pr_pls, double pr, double pr_mns){
   return( (pr_pls!=0 && pr>=pr_pls) || 
           (pr_mns!=0 && pr<=pr_mns) ); }

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
datetime iTime(string symbol, ENUM_TIMEFRAMES tf, int index){   
   if(index < 0) return(-1);
   datetime Arr_[1];
   int copy=CopyTime(symbol,tf,index,1,Arr_); 
   if(copy>0) return(Arr_[0]);
   else return(0);}

double  NormalizeLot(string symbol, double lot){
   double _lot=lot<SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN)?SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN):
              (lot>SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX)?SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX):lot);
         _lot=MathCeil(_lot/SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP))*SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP);
  return(_lot);}

bool Signal(){
   return((MathRand()%2)==0);}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
bool Fn_profit_summ(string &str, double &profit_summ, bool is_buy, ulong magic){
   profit_summ = 0;
   str="";
   //-----------------------------             
   int total = PositionsTotal();          
   for(int i=total-1; i>=0; i--){
      const ulong tic= PositionGetTicket(i); if(tic<=0)     return(false); //--- asinchr
      if(!PositionSelectByTicket(tic)                   )   return(false); //--- asinchr 
      bool is_buy_ = (PositionGetInteger(POSITION_TYPE  )==POSITION_TYPE_BUY); 
      if( is_buy_                             !=  is_buy)   continue; 
      if( PositionGetInteger(POSITION_MAGIC ) !=  magic )   continue;
      if( PositionGetSymbol (POSITION_SYMBOL) != _Symbol)   continue;
      double prof = PositionGetDouble(POSITION_PROFIT)+PositionGetDouble(POSITION_SWAP); 
      profit_summ += prof;
      str+="  ("+IntegerToString(tic)+" | "+DoubleToString(prof, 2)+")  ";
      }
   //-----------------------------
   return(true);}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
bool Fn_ord_cls_all(int is_buy, ulong magic){
   //-----------------------------    
   int total = PositionsTotal();          
   for(int i=total-1; i>=0; i--){
      const ulong tic= PositionGetTicket(i); if(tic<=0)     return(false); //--- asinchr  
      if(!PositionSelectByTicket(tic)                   )   return(false); //--- asinchr  
      if( PositionGetInteger(POSITION_MAGIC ) !=  magic )   continue;
      if(is_buy>=0 && (PositionGetInteger(POSITION_TYPE  )==POSITION_TYPE_BUY)!=is_buy) continue; 
      if( PositionGetSymbol (POSITION_SYMBOL) != _Symbol)   continue;
      gl_trade.PositionClose(tic);}
   //-----------------------------    
      total = OrdersTotal();          
   for(int i=total-1; i>=0; i--){
      const ulong tic= OrderGetTicket(i); if(tic<=0)      return(false); //--- asinchr  
      if(!OrderSelect(tic)                            )   return(false); //--- asinchr  
      if( OrderGetInteger(ORDER_MAGIC )!=  magic      )   continue;
      if(is_buy>=0 && ((OrderGetInteger(ORDER_TYPE  )%2)==0)!=is_buy) continue; 
      if( OrderGetString (ORDER_SYMBOL)!= _Symbol     )   continue;
      gl_trade.OrderDelete(tic);}
   //-----------------------------
   return(false);}

